-- Deploy camper:home_carousel to pg
-- requires: roles
-- requires: schema_camper
-- requires: company
-- requires: media
-- requires: user_profile

begin;

set search_path to camper, public;

create table home_carousel (
	media_id integer not null references media primary key,
	caption text not null,
	position integer not null default 2147483647
);

grant select on table home_carousel to guest;
grant select on table home_carousel to employee;
grant select, insert, update, delete on table home_carousel to admin;

alter table home_carousel enable row level security;

create policy guest_ok
on home_carousel
for select
using (true)
;

create policy insert_to_company
on home_carousel
for insert
with check (
	exists (select 1 from media join user_profile using (company_id) where media.media_id = home_carousel.media_id)
)
;

create policy update_company
on home_carousel
for update
using (
	exists (select 1 from media join user_profile using (company_id) where media.media_id = home_carousel.media_id)
)
;

create policy delete_from_company
on home_carousel
for delete
using (
	exists (select 1 from media join user_profile using (company_id) where media.media_id = home_carousel.media_id)
)
;

commit;
